unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls, ComCtrls, dsReport,
  XPMan, ExtCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Table2: TTable;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    Button1: TButton;
    Button2: TButton;
    DBGrid3: TDBGrid;
    Table3: TTable;
    DataSource3: TDataSource;
    Button3: TButton;
    Button4: TButton;
    XPManifest1: TXPManifest;
    cbUseDBEx: TCheckBox;
    Button5: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Table1AfterScroll(DataSet: TDataSet);
    procedure Button5Click(Sender: TObject);
  private
    procedure OnGetSecondVariable(Variable: TdsrVariable);
    procedure ReportDesign(design, biolife: Boolean);
    procedure MyUserInput(Sender: TObject; Action: Integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses dsSectionFile, dsPrinter, dsReportDesigner, dsrDB,
     dsrDBEx, dsrReportWizard, pdf;

procedure TForm1.FormCreate(Sender: TObject);
begin
  varDefaultFontName := 'Arial';
  varDefaultFontSize := 10;
  varDefaultCharset := EASTEUROPE_CHARSET;

  Table1.Open;
  Table2.Open;
  Table3.Open;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ReportDesign(true, false);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ReportDesign(false, false);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ReportDesign(true, true);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  ReportDesign(false, true);
end;

procedure TForm1.OnGetSecondVariable(Variable: TdsrVariable);
begin
  ShowMessage('Get variable value from delphi code');
  Variable.Value := 'Hello world';
end;

procedure TForm1.ReportDesign(design, biolife: Boolean);
var
  p: TdsrReport;
  d: TdsrReportDesigner;
  sf: TdsSectionFile;
  t: TdsrDBdatasetEx;
begin
  if design then
  begin
    d := TdsrReportDesigner.Create(nil);
  end
  else
  begin
    d := nil;
    if not OpenDialog1.Execute then
      Exit;
    Table1.First;
  end;

  p := TdsrReport.CreateEx(nil, true);
  try
    p.Name := 'Report1';
    p.OnUserInput := MyUserInput;

    if biolife then
    begin
      dsrAddDBDataset('Biolife', Table3, p);
    end
    else
    begin
      if cbUseDBEx.Checked then
      begin
        //if you use DBEx you can print or design DBEx.rpt
        //there you can see that field EmpNo.LastName can be printed
        //DBEx knows how to create lookup table and use lookup field
        //that is defined right here with AddLookupField
        //notice plus sign in front of field EmpNo at design time
        t := dsrCreateDBDatasetEx('Master', Table1, p);
        with t do
        begin
          AddLookupField('EmpNo', 'employee', 'EmpNo');
        end;
        p.AddDataset(t);

        t := dsrCreateDBDatasetEx('Detail', Table2, p);
        p.AddDataset(t);
      end
      else
      begin
        dsrAddDBDataset('Master', Table1, p);
        dsrAddDBDataset('Detail', Table2, p);
      end;

      with p.Variables.Add do
      begin
        Name := 'MyVariable';
        Category := 'MyCategory';
        Value := 'MyValue';
      end;

      with p.Variables.Add do
      begin
        Name := 'SecondVariable';
        OnGetValue := OnGetSecondVariable;
      end;
    end;

    if design then
    begin
      d.Report := p;

      //d.OnOpen := MyOpen;
      //d.OnSaveAs := MySaveAs;
      //d.OnSave := MySave;
      d.Execute;
    end
    else
    begin
      sf := TdsSectionFile.Create;
      try
        sf.LoadFromFile(OpenDialog1.FileName);
        p.Page.Assign(sf.SectionByName(cPageSection).Strings);
        p.Code.Assign(sf.SectionByName(cCodeSection).Strings);
        { uncomment this if you want to print two reports in one print job
        p.PrintReport;

        sf.LoadFromFile(ExtractFilePath(OpenDialog1.FileName) + 'script02.rpt');
        p.Page.Assign(sf.SectionByName(cPageSection).Strings);
        p.Code.Assign(sf.SectionByName(cCodeSection).Strings);

        p.PrintReport;
        }
      finally
        sf.Free;
      end;
      p.Preview;
    end;

  finally
    p.Free;
    d.Free;
  end;
end;

procedure TForm1.Table1AfterScroll(DataSet: TDataSet);
begin
  Table2.Filter := 'OrderNo = ' + Table1.FieldByName('OrderNo').AsString;
  Table2.Filtered := true;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  ReportWizard(DBGrid1, 'Master');
end;

procedure TForm1.MyUserInput(Sender: TObject; Action: Integer);
var
  s: String;
begin
  case Action of
    1:
      begin
        s := InputBox('Setup labels', 'First label to print', '1');
        try
          (Sender as TdsrBand).FirstLabel := StrToInt(s);
        except
        end;
      end;
  end;
end;

end.
